/*=============================================================================
//
//      icontext.c
//
//      SPARC HAL context init function
//
//=============================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//=============================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):   hmt
// Contributors:        hmt
//               Gaisler Research (Konrad Eisele<eiselekd@web.de>) (fpu support)
// Date:        1998-12-14
// Purpose:     HAL context initialization function
// Description: Initialize a HAL context for SPARC; this is in C and out
//              of line because there is too much of it for a simple macro.
//
//####DESCRIPTIONEND####
//
//===========================================================================*/

#include <pkgconf/hal.h>
#include <pkgconf/kernel.h>

#include <cyg/hal/hal_arch.h>           // HAL header

#include <cyg/infra/cyg_type.h>

#include <cyg/hal/vectors.h>            // SAVE_REGS_SIZE, __WINSIZE, ...
#include <cyg/kernel/thread.hxx>
#include <cyg/kernel/sched.hxx>

extern "C" {

/* grmon var init */
int var_CYGVAR_KERNEL_THREADS_LIST = 
#ifdef CYGVAR_KERNEL_THREADS_LIST
	1;
#else
        0;
#endif
unsigned int var_Cyg_Thread_thread_list = 0;
unsigned int var_Cyg_Thread_thread_list_next_off = 0;
unsigned int var_Cyg_Thread_stack_ptr_off = 0;
unsigned int var_Cyg_Thread_stack_base_off = 0;
unsigned int var_Cyg_Thread_stack_size_off = 0;
unsigned int var_Cyg_Thread_name_off = 0;
unsigned int var_Cyg_Thread_state_off = 0;
unsigned int var_Cyg_Thread_current_addr = 0;
	
int
hal_sparc_grmon(void) 
{
#ifdef CYGVAR_KERNEL_THREADS_LIST
	var_CYGVAR_KERNEL_THREADS_LIST = 1;
#else
	var_CYGVAR_KERNEL_THREADS_LIST = 0;
#endif
#ifdef CYGVAR_KERNEL_THREADS_LIST
	var_Cyg_Thread_thread_list = (unsigned int)Cyg_Thread::grmon_get_list_head_addr();
	var_Cyg_Thread_thread_list_next_off = (unsigned int)Cyg_Thread::grmon_get_list_next_off();
	var_Cyg_Thread_stack_ptr_off = (unsigned int)Cyg_Thread::grmon_get_stack_ptr_off();
	var_Cyg_Thread_stack_base_off = (unsigned int)Cyg_Thread::grmon_get_stack_base_off();
	var_Cyg_Thread_stack_size_off = (unsigned int)Cyg_Thread::grmon_get_stack_size_off();
#ifdef CYGVAR_KERNEL_THREADS_NAME
	var_Cyg_Thread_name_off = (unsigned int)Cyg_Thread::grmon_get_name_off();
#endif
#endif
	var_Cyg_Thread_state_off = (unsigned int)Cyg_Thread::grmon_get_state_off();

	var_Cyg_Thread_current_addr = (unsigned int)Cyg_Scheduler_Base::grmon_get_current_thread_addr();
	
	return 0;
}

}

